#!/bin/sh

wns_is_ssu=0

# this sesstion is auto-generated by KB_manage system
# ---- start ----
wns_dev_archive_number="KB-WACAP-20200924-aqld"
wns_package_seq="3.3.8"

wns_version_list="WAC3.3.8,vWAC3.3.8"
wns_catagory="wac"
wns_machine_list=""
wns_machine_except_list=""
wns_machine_reboot=0

# delete procedure
delete_procedure() {
	return 0
}
# prerun function
wns_function_before_unpack() {
mount -o remount rw /
mkdir -p /wns/webui/application/third_party/pkg/jwt
mkdir -p /wns/webui/application/third_party/pkg/jwt/src
rm  /wns/webui/tmppic -r
mkdir -p /wns/data/webui/tmppic
chown nobody:nobody -R /wns/data/webui/tmppic
ln -s /wns/data/webui/tmppic /wns/webui/tmppic
chown nobody:nobody /wns/webui/tmppic

	delete_procedure
	return 0
}
# postrun function
wns_function_after_unpack() {
appinit_cli restart crond
rm -rf /wns/webui/WLAN/cache/* && rm -rf /var/log/nginx/get_js_cache/*
/wns/shell/restart_web_service
dos2unix  /wns/etc/rc2.d/S01initdir
sed -i '115s/Allow from all/Deny from all\n    \<FilesMatch \"php-cgi\">\n        Order allow,deny\n        Allow from all\n\    <\/FilesMatch>/' /wns/data/ac_root/etc/apache2/vhosts.d/ctrlsvr.include
chroot /wns/data/ac_root/
apache2ctl restart

	return 0
}
# ---- end ----



###########################################################################
# 全局变量
# wns_is_ssu 
# wns_dev_archive_number
# wns_package_seq
# wns_machine_reboot=0
# wns_catagory=wac,miniwac,ap


#升级时间
wns_update_time=`date +%Y%m%d-%H%M%S`

if [ ! -f "/usr/sbin/dirname" ] && [ ! -f "/sbin/dirname" ] && [ ! -f "/usr/bin/dirname" ] && [ ! -f "/bin/dirname" ];then
	alias dirname="busybox dirname"
fi
wns_package_path=`dirname $0`
if [ $wns_is_ssu -eq 1 ];then
	wns_package="$wns_package_path/app"
else
	wns_package="$wns_package_path/${wns_dev_archive_number}_package-${wns_package_seq}.tgz"
fi

wns_rollback_script="KB-WACAP-rollback.sh"
wns_rollback_alert="KB-WACAP-rollback-alert.txt"
wns_appversion="/app/appversion"
wns_kbversion="/app/kbversion"
wns_hwinfo="/etc/hwinfo"


wns_function_self_check()
{
	#return 0 success， 1 failed
	return 0
}

###############################################################
wns_update_log="/app/wns_updatekb.log"

wns_echo()
{
    echo $1
    echo $1 >>$wns_update_log    
}

wns_ro_fail_exit()
{
    mount / -o ro,remount
    exit -1
}

mount -o remount,rw /

#
wns_check_catagory()
{
    if [ ! -f ${wns_hwinfo} ]; then
        wns_echo "${wns_hwinfo} not exist.Interrupt and exit";
        wns_ro_fail_exit
    fi   

    local arch=`grep type ${wns_hwinfo} | awk -F= '{print $NF}'`;
    local product=`grep product ${wns_hwinfo} | awk -F= '{print $NF}'`;
    local dev_catagory=""
    if [ "x${arch}" == "xmips" -a "x${product}" == "xWAC" ];then
        dev_catagory="miniwac"
    elif [ "x${arch}" == "xx86" -a "x${product}" == "xWAC" ];then
        dev_catagory="wac"
    elif [ "x${arch}" == "xmips" -a "x${product}" == "xAP" ];then
        dev_catagory="ap"
    fi

    if [ "x${dev_catagory}" == "x" ];then
        wns_echo "Device Catagory[${dev_catagory}]. unknown catagory. Please check ${wns_hwinfo}. now exit."
        wns_ro_fail_exit
    fi

    if [ "x${dev_catagory}" != "x${wns_catagory}" ];then
        wns_echo "Device Catagory[${dev_catagory}]. unmatched catagory"
        wns_ro_fail_exit
    fi
}
wns_check_catagory

if [ "$wns_package" != "" ] && [ ! -f "$wns_package" ]; then
    wns_echo "$wns_package not exist, update failed."
    wns_ro_fail_exit
fi

#检测是否含有软连接
wns_check_tar_bomb()
{
    for item in `tar -tvzf ${wns_package} | awk '{print $6}'`
    do
        echo ${item} | grep -qE "/$"
	    if [ $? -eq 0 ]; then
			#this item is directory
			if [ -L /${item%/} ]; then
					wns_echo "this kb has error, because "/${item%/}" is symlink"
					wns_ro_fail_exit
			fi
		fi
    done
}
wns_check_tar_bomb

# 检测硬件平台是否支持
wns_machine_check_ok()
{
    #hwinfo文件不存在，则不允许升级。
    if [ -f "${wns_hwinfo}" ]; then
        wns_machine_type=`grep model ${wns_hwinfo} | awk -F= '{print $NF}'`
    else
        wns_echo "${wns_hwifo} not exist. Hardware maybe not match"
        wns_ro_fail_exit
    fi
	
	#只要在支持列表里面有即通过，在支持列表非空的情况下，没有匹配上则不通过
	if [ "$wns_machine_list" != "" ];then
		for wns_mtype in $wns_machine_list
		do
			if [ "$wns_mtype" == "$wns_machine_type" ];then
				wns_echo "machine type check ok"
				return 0
			fi
		done
		wns_echo "Hardware type mismatch, update failed"
		wns_ro_fail_exit
	fi
	
	#在except列表里面的，表示不支持该平台，存在即不通过
	if [ "$wns_machine_except_list" != "" ];then
		for wns_mtype in ${wns_machine_except_list}
		do
			if [ "$wns_mtype" == "$wns_machine_type" ];then
				wns_echo "Type of hardware does not support, update failed"
				wns_ro_fail_exit
			fi
		done
	fi
	return 0
}

#wns_max_R_SP_seq=20
#
#获取R版本和SP版本的版本号,他们互斥
#wns_R_SP_version_get()
#{
#    # 获取R版本信息,e.g WAC1.0.0R2 
#	wns_R_seq=${wns_max_R_SP_seq}
#	while [ ${wns_R_seq} -gt 0 ]
#	do
#		if grep -E "^(WAC|MINIWAC).*${1}.*R${wns_R_seq}" ${wns_appversion};then
#			wns_version_suffix="R${wns_R_seq}"
#			return 0
#		fi
#		wns_R_seq=`expr ${wns_R_seq} - 1`
#	done
#
#   # 获取SP版本信息,e.g. WAC1.0.0SP2
#	wns_SP_seq=${wns_max_R_SP_seq}
#	while [ ${wns_SP_seq} -gt 0 ]
#	do
#		if grep -E "^(WAC|MINIWAC).*${1}.*SP${wns_SP_seq}" ${wns_appversion};then
#			wns_version_suffix="SP${wns_SP_seq}"
#			return 0
#		fi
#		wns_SP_seq=`expr ${wns_SP_seq} - 1`
#	done
#
#	return 1
#}
#
## 定制版本号
#wns_custom_R_SP_version_get()
#{
#	wns_R_seq=${wns_max_R_SP_seq}
#	while [ ${wns_R_seq} -gt 0 ]
#	do
#		if grep -E "^custom-build.*${1}R${wns_R_seq}" ${wns_appversion};then
#			wns_version_suffix="R${wns_R_seq}"
#			return 0
#		fi
#		wns_R_seq=`expr ${wns_R_seq} - 1`
#	done
#
#	wns_SP_seq=${wns_max_R_SP_seq}
#	while [ ${wns_SP_seq} -gt 0 ]
#	do
#		if grep -E "^custom-build.*${1}SP${wns_SP_seq}" ${wns_appversion};then
#			wns_version_suffix="SP${wns_SP_seq}"
#			return 0
#		fi
#		wns_SP_seq=`expr ${wns_SP_seq} - 1`
#	done
#
#	return 1
#}

#检测软件版本是否支持。
wns_version_check_ok()
{
    #TODO 需要确定kb系统中的版本列表带不带build号
    wns_whole_ver=`head -n 1 ${wns_appversion} | awk -F- '{print $1}'`

    if [ "${wns_version_list}" == "" ];then
        wns_echo "must set version support list, update failed"
        wns_ro_fail_exit
    fi

#    for iter in ${wns_version_list}
#    do
#	echo "${wns_whole_ver}" | grep ^"${iter}" >/dev/null 2>&1
#        if [ $? -eq 0  ];then
#            wns_echo "version check ok"
#            return 0
#        fi
#    done

    #echo "${wns_version_list}" | grep "${wns_whole_ver}" >/dev/null 2>&1
    #if [ $? -eq 0  ];then
        #wns_echo "version check ok"
        #return 0
    #fi
	
	i=1  
	while((1==1))  
	do  
			split=`echo ${wns_version_list}|cut -d "," -f$i`  
			if [ "$split" != "" ]  
			then  
					((i++))  
					#echo $split
					if [ "$split" == "${wns_whole_ver}" -o "$split" == "WAC_ALLVERSION" ]; then
						wns_echo "version check success"
						return 0;
					fi
					echo ${wns_version_list} |grep "," >/dev/null 2>&1
					if [ $? -ne 0  ];then
						break
					fi
			else  
					break
			fi  
	done
    wns_echo "version check failed, update failed"
    wns_ro_fail_exit
}

#版本检测
wns_version_check_ok
#硬件检测
wns_machine_check_ok
#
wns_function_self_check
if [ $? -ne 0 ];then
	wns_echo "Self check failed, update failed"
	wns_ro_fail_exit
fi

#将所有的非正式版都认为是定制
wns_custom_version_check_ok()
{
    # 0不是定制 1定制
    local is_custom=0

    # 客户定制
    if grep -E "custom-build" ${wns_appversion};then
        is_custom=1
        return $is_custom
    fi 

    # KB定制
    if grep -E "custom-build" ${wns_kbversion};then
        is_custom=1
        return $is_custom
    fi
    return $is_custom
}

#定制技术支持检测 TODO 这些标记不知道要打到什么地方
wns_custom_version_check_ok
if [ $? -ne 0 ]; then
	wns_echo "It is a custom version, Looking for R&D recognition"
	if [ ${wns_is_ssu} -eq 1 ];then
	    wns_ro_fail_exit
	fi
	wns_echo "Do you want to continue ? y/n :"
	while read wns_confirm
	do
		if [ "${wns_confirm}" != "Y" ] && [ "${wns_confirm}" != "y" ];then
			wns_echo "custom check failed,update failed"
			wns_ro_fail_exit
		else
			wns_echo "confirm custom ok"
			break
		fi
	done
fi

if [ ${wns_is_ssu} -eq 1 ];then
	wns_depart="dev"
else
	#操作者部门
	wns_echo "Please input your department(dev or cti):"
	while read wns_depart
	do
		if [ "${wns_depart}" != "dev" ] && [ "${wns_depart}" != "cti" ];then
			wns_echo "please input dev or cti, again"
			wns_echo "Please input your department(dev or cti):"
		else
			wns_echo "you choice ${wns_depart} now"
			break
		fi
	done
	
	#操作者名字
	wns_echo "Please input your name:"
	while read wns_whoiam
	do
		if [ "x${wns_whoiam}" == "x" ];then
			wns_echo "Please input your name:"
		else
			wns_echo "you input name : ${wns_whoiam}"
			break
		fi
	done
	
	#TD号
	wns_echo "Please input bug TD number(for example TDxxxx, empty when no TD number):"
	read wns_td_number  
fi


#创建备份目录 TODO lwj指定目录
wns_backup_root="/wns/backup"
mkdir -p "${wns_backup_root}"
wns_sequence=`ls -l "${wns_backup_root}/" | grep ^d | wc -l`
wns_sequence=`expr ${wns_sequence} + 1`
if [ ${wns_sequence} -lt 10 ];then
	wns_sequence="00${wns_sequence}"
else
	if [ ${wns_sequence} -lt 100 ];then
		wns_sequence="0${wns_sequence}"
	fi
fi

wns_backup_top="${wns_backup_root}/${wns_sequence}"
wns_backup_rollback="${wns_backup_top}/KB-WACAP-rollback-custom.sh"
wns_backup_newlist="${wns_backup_top}/.new_list"
wns_backup_oldlist="${wns_backup_top}/.old_list"
wns_backup_info="${wns_backup_top}/.info_list"
wns_backup_dir="${wns_backup_top}/bak"
wns_chglog_file="${wns_backup_top}/changelog.txt"
wns_untar_dir="/stmp/kb_dir"
wns_untar_dir_len=${#wns_untar_dir}

mkdir -pv ${wns_backup_dir}
if [ $? -ne 0 ];then
	wns_echo "can not create backup dirctory, update failed"
	wns_ro_fail_exit
fi


#生成操作日志脚本
wns_changelog_sh="/tmp/${wns_depart}_${wns_name}_${wns_update_time}_${wns_sequence}.sh"
if [ -f "${wns_changelog_sh}" ];then
	rm -f ${wns_changelog_sh}
fi
#生成操作日志头
echo "#! /bin/sh" >>${wns_changelog_sh}
if [ ! -f "${wns_changelog_sh}" ];then
	wns_echo "can not create ${wns_changelog_sh}, update failed"
	wns_ro_fail_exit
fi
echo "echo \"version ${wns_whole_ver} Looking for ${wns_dev_archive_number}-${wns_package_seq} (developer ori archive)\">>${wns_chglog_file}" >>${wns_changelog_sh}

#rollback_log
echo "echo \"datetime=${wns_update_time}\" >${wns_backup_info}" >>${wns_changelog_sh}
echo "echo \"author=${wns_whoiam}\" >>${wns_backup_info}" >>${wns_changelog_sh}
echo "echo \"kbflag=${wns_dev_archive_number}-${wns_package_seq}\" >>${wns_backup_info}" >>${wns_changelog_sh}
echo "echo \"dept=${wns_depart}\" >>${wns_backup_info}" >>${wns_changelog_sh}
echo "echo \"TDnumber=${wns_td_number}\" >>${wns_backup_info}" >>${wns_changelog_sh}

wns_chg_add_file()
{
	echo "echo \"add ${1}\" >>${wns_chglog_file}" >>${wns_changelog_sh}
	echo "wns_md5_add=\`md5sum ${1}\`" >>${wns_changelog_sh}
	echo "echo \"  +new: \${wns_md5_add}\">>${wns_chglog_file}">>${wns_changelog_sh}
}

wns_chg_modify_file()
{
	echo "echo \"modify ${1}\">>${wns_chglog_file}" >>${wns_changelog_sh}
	echo "wns_md5_del=\`md5sum ${wns_backup_dir}/${1}\`">>${wns_changelog_sh}
	echo "wns_md5_add=\`md5sum ${1}\`">>${wns_changelog_sh}
	echo "echo \"  -old: \${wns_md5_del}\">>${wns_chglog_file}" >>${wns_changelog_sh}
	echo "echo \"  +new: \${wns_md5_add}\">>${wns_chglog_file}" >>${wns_changelog_sh}
}

wns_chg_delete_file()
{
    echo "echo \"delete ${1}\">>${wns_chglog_file}" >>${wns_changelog_sh}
	echo "wns_md5_del=\`md5sum ${wns_backup_dir}/${1}\`">>${wns_changelog_sh}
	echo "echo \"  -old: \${wns_md5_del}\">>${wns_chglog_file}" >>${wns_changelog_sh}
}

wns_chg_create_dir()
{
	echo "echo \"create new directory :${1}\">>${wns_chglog_file}" >>${wns_changelog_sh}
}

#$1 设备上文件, 绝对路径
wns_rollback_add_file()
{
    #echo "`md5sum $1`">>${wns_rollback_newlist}   
    local tmp=`md5sum $1`
    local tmp_md5=`echo $tmp | cut -d " " -f 1`
    local tmp_fil=`echo $tmp | cut -d " " -f 2`
    echo "echo \"$tmp_md5:$tmp_fil\">>${wns_backup_newlist}" >>${wns_changelog_sh}
}
wns_rollback_del_file()
{
    #echo "`md5sum $1`">>${wns_rollback_oldlist}  
    local tmp=`md5sum $1`
    local tmp_md5=`echo $tmp | cut -d " " -f 1`
    local tmp_fil=`echo $tmp | cut -d " " -f 2`
    echo "echo \"$tmp_md5:$tmp_fil\">>${wns_backup_oldlist}" >>${wns_changelog_sh}
}

#被公共函数调用，$1完整路径
wns_delete_file()
{
	if [ -f "${1}" ];then
		wns_chg_delete_file $1
        wns_rollback_del_file $1

        mkdir -p `dirname ${wns_backup_dir}/$1`
		mv $1  ${wns_backup_dir}/$1
	fi
}

## 真正备份文件
#if [ -f "${wns_package}" ];then
#	wns_bak_tar_list=`tar -tzvf ${wns_package} | awk '{print $6}'`
#	for wns_file in ${wns_bak_tar_list}; do
#		if [ -e "/${wns_file}" ];then
#			if [ -f "/${wns_file}" ];then
#				wns_chg_modify_file "/${wns_file}"
#               mkdir -p `dirname ${wns_backup_dir}/${wns_file}`
#				cp -f /${wns_file} ${wns_backup_dir}/${wns_file}  #备份被覆盖的文件
#               wns_rollback_del_file "/${wns_file}" #替换前的文件
#			fi
#		else
#			wns_file_is_dir=`echo ${wns_file} | awk -F/ '{print $NF}'`
#			if [ "${wns_file_is_dir}" != "" ];then
#				wns_chg_add_file "/${wns_file}" #
#			fi
#		fi
#	done
#fi

wns_failure_exit()
{
    wns_echo "$1"

    rm -rf ${wns_backup_top}

    rm -rf ${wns_untar_dir}
    mount -o remount,ro /
    exit -1
}

#mount -o remount,rw /

#modify by cz 2015-1-26 for TD123
# 备份appversion文件,不恢复appversion，用于回滚是检测使用。-- by cz
mkdir -p  "`dirname ${wns_backup_dir}/${wns_appversion}`"
cp -f ${wns_appversion} ${wns_backup_dir}/${wns_appversion}
#wns_chg_modify_file "${wns_appversion}"
#wns_rollback_del_file "${wns_appversion}"

# 备份kbversion文件
if [ ! -e ${wns_kbversion} ]; then
    touch ${wns_kbversion}
fi
mkdir -p  "`dirname ${wns_backup_dir}/${wns_kbversion}`"
cp -f ${wns_kbversion} ${wns_backup_dir}/${wns_kbversion}
wns_chg_modify_file "${wns_kbversion}"
wns_rollback_del_file "${wns_kbversion}"

#备份hwinfo文件，只备份不恢复，用于回滚时检测使用
mkdir -p  "`dirname ${wns_backup_dir}/${wns_hwinfo}`"
cp -f ${wns_hwinfo} ${wns_backup_dir}/${wns_hwinfo}
#wns_chg_modify_file "${wns_hwinfo}" 
#wns_rollback_del_file "${wns_hwinfo}" 不备份hwinfo文件

#开始打包和备份
#mount / -o rw,remount
wns_function_before_unpack
if [ -f "${wns_package}" ];then
    rm -rf "${wns_untar_dir}"
    mkdir -p "${wns_untar_dir}"
    if [ $? -ne 0 ]; then
        wns_failure_exit "create untar directory failed. exit"
    fi

	tar -zxvf ${wns_package} -C "${wns_untar_dir}"
    if [ $? -ne 0 ];then  
		wns_failure_exit "tar failed $?, update failed , please Looking for developer"
	fi

    for tmp_item in `find ${wns_untar_dir} -type f`
    do
        echo "current file:$tmp_item"
        # wns_dev_file是绝对路径
        wns_dev_file=${tmp_item:$wns_untar_dir_len}
        if [ -e "${wns_dev_file}" ];then
           	if [ -f "${wns_dev_file}" ];then  # 替换操作
                wns_chg_modify_file "${wns_dev_file}"
                mkdir -p `dirname ${wns_backup_dir}/${wns_dev_file}`
	            cp -f ${wns_dev_file} ${wns_backup_dir}/${wns_dev_file}  #备份被覆盖的文件
				#modify by cz 2015-1-26 for TD 181
				#wns_rollback_del_file ${wns_dev_file}应该放在这里才对，放在cp -f ${tmp_item}  ${wns_dev_file}之后就不对了。--by cz
                wns_rollback_del_file ${wns_dev_file}				
				rm -f ${wns_dev_file}
                cp -f ${tmp_item}  ${wns_dev_file}
				#wns_rollback_del_file ${wns_dev_file}							
                wns_rollback_add_file ${wns_dev_file}
            fi
        else # 增加文件
            wns_chg_add_file "${wns_dev_file}"
            cp -f ${tmp_item}  ${wns_dev_file}
            wns_rollback_add_file ${wns_dev_file}
        fi
    done

    rm -rf "${wns_untar_dir}"
fi

# 增加本次KB包标示
echo "custom-build ${wns_update_time} support information " >>${wns_kbversion}
echo "support-build ${wns_depart} support ${wns_whoiam} ${wns_update_time} ${wns_sequence} ${wns_td_number} ${wns_dev_archive_number}-${wns_package_seq}" >>${wns_kbversion}

wns_function_after_unpack

# 检测回滚前执行脚本是否存在。
if [ -f "${wns_package_path}/KB-WACAP-rollback-custom.sh" ]; then
    cp -f "${wns_package_path}/KB-WACAP-rollback-custom.sh"  "${wns_backup_rollback}" && chmod a+x "${wns_backup_rollback}"
fi

# 检测回滚脚本是否存在。
if [ -f "${wns_package_path}/${wns_rollback_script}" ]; then
    cp -f "${wns_package_path}/${wns_rollback_script}"  "${wns_backup_root}/${wns_rollback_script}" && chmod a+x "${wns_backup_root}/${wns_rollback_script}"
fi

# 检测回滚提示脚本是否存在。
if [ -f "${wns_package_path}/${wns_rollback_alert}" ]; then
    cp -f "${wns_package_path}/${wns_rollback_alert}"  "${wns_backup_root}/${wns_rollback_alert}" && chmod a+x "${wns_backup_root}/${wns_rollback_alert}"
fi

# 生成操作日志
chmod +x ${wns_changelog_sh}
${wns_changelog_sh}
rm -f ${wns_changelog_sh}
sync

wns_echo "Update successfully"
wns_echo "Please view the updated log ${wns_chglog_file}"

# 重启设备
if [ ${wns_machine_reboot} -ne 0 ] && [ ${wns_is_ssu} -eq 0 ];then
	wns_echo "Please confirm for reboot now: (y/n)?"
	while read wns_machine_reboot_now
	do
		if [ "${wns_machine_reboot_now}" == "Y" ] ||  [ "${wns_machine_reboot_now}" == "y" ];then
			for((wns_i=0;wns_i<10;wns_i++))
			do
				wns_left_time=`expr 10 - ${wns_i}`
				wns_echo "Reboot after ${wns_left_time}s (Ctrl+c for cancel reboot)"
				sleep 1
			done
			wns_echo "reboot now"
			reboot
		else
			if [ "${wns_machine_reboot_now}" == "N" ] || [ "${wns_machine_reboot_now}" == "n" ];then
				wns_echo "Warring !!! please reboot later ...."
				break
			fi
		fi
	done
fi

mount / -o ro,remount

exit 0


