<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

/**
 * 本控制器所有方法，无需登录认证就可访问
 * 如不公开的请求请勿写在本控制器
 */
class Welcome extends SF_Controller {

	/**
	 * 登录次数还剩如下次数的时候提示剩余登录机会
	 */
	protected $_last_changes = array(1, 2);

	// --------------------------------------------------------------------

	/**
	 * 从URL提取登录页消息信息
	 *
	 * @return				string
	 */
	protected function _get_msg() 
	{
		$msg = strip_tags(trim(strval($this->input->get('msg'))));
//		$msg = mb_substr($msg, 0, 25, 'UTF-8'); //登录页消息提示只显示前25个字符，由开发者自己拿捏
		if (false == $this->input->server('HTTP_REFERER')) //非重定向来的请求不显示提示
		{
			return '';
		}

		$scheme = $this->input->server('REQUEST_SCHEME');
		$scheme = 'https'; //用了waf后，上面判断就失真
		if (!$scheme) 
		{
			$https = (string)$this->input->server('HTTPS');
			if (0 === strcasecmp('on', $https)) 
			{
				$scheme = 'https';
			}
			else
			{
				$scheme = 'http';
			}
		}
		$host = $this->input->server('HTTP_HOST');
		$referer = $this->input->server('HTTP_REFERER');
		$ref = sprintf('%s://%s', $scheme, $host);
		if (0 === stripos($referer, $ref)) 
		{
			return $msg;
		}
		return '';
	}

	// --------------------------------------------------------------------

	/**
	 * 
	 */
	public function index()
	{
        database_upgrade();
        if(is_branch_wac() && isset($_GET['super']) && intval($_GET['super']) == 1 && isset($_GET['token']))
        {
            if (false === $this->_check_sso_login_token($_GET['token']))
            {
                $this->_unset_auth();
                set_status_header(302);
                log_message_r('error', 'sso login token error '.__FILE__.':'.__LINE__);
                header('Location:' . LOGIN_URL); //回登录页
                header('X-POS: '. sprintf('%s:%d', 'WEL', __LINE__));
                exit;
            }
            //单点登录免登陆
            $sess_cookie_name = $this->configs['sess_cookie_name'];
            if (isset($_COOKIE[$sess_cookie_name]))
            {
                $file = is_session_file($_COOKIE[$sess_cookie_name]);
            }
            if(!is_file($file))
            {
//                exec("grep https_port /wns/etc/config/wac/wns_cfg_wl_g_basic.xml | awk -F\> '{print $2}' | awk -F\< '{print $1}'", $output, $code);

                $https_port = g_get_item_from_file('/wns/etc/config/wac/wns_cfg_wl_g_basic.xml', 'https_port');
                if ($https_port !== '')
                {
                    $temp = explode(':',$_SERVER['HTTP_HOST']);
                    if ((isset($temp[1]) && intval($temp[1])!= intval($https_port)))
                    {
                        $this->load->library('acl/simple_user', null, 'user');
                        $info = $this->user->get_super();
                        $role_valid = $info['role'] === ROLE_SUPER;
                        if ($role_valid)
                        {
                            $this->load->model('system_management/admin_account/admin_account_model');
                            $pwd = $this->admin_account_model->pwd_dencypt($info['password']);
                            //构造参数登陆
                            $this->forms = array('username' => $info['id'], 'password' => $pwd);
                            $_SERVER['REQUEST_METHOD'] = 'POST';
                            $this->login();
                        }

                    }
                }
            }
        }
        $this->session->start();
		if (!$this->session->userdata('auth')) //走入这里可能是会话文件所在目录不可写，或没有足够磁盘空间
		{
            //判断如果是获取版本信息就返回版本信息
            if (isset($_REQUEST['version']) && (bool)$_REQUEST['version'])
            {
                echo $this->get_version_info();
                $this->_unset_auth();
                exit;
            }
			$this->_unset_auth();
			set_status_header(302);
            log_message_r('error', 'redirect to login page '.__FILE__.':'.__LINE__);
			header('Location:' . LOGIN_URL); //回登录页
			//echo $this->load->view(__CLASS__ . '/redirect', array('url'=>LOGIN_URL), true);
			header('X-POS: '. sprintf('%s:%d', 'WEL', __LINE__));
			exit;
		}
		$_SERVER['HTTP_SESSION_TOKEN'] = $this->session->userdata(static::CSRF_TOKEN);
		if (!$this->session->userdata('renew') || 1 == @$_REQUEST['renew'])
		{
			$this->session->set_userdata('renew', 1);
			$this->session->close();
			$this->session->unset_userdata(Runtime_Model::LANGUAGE);
			$this->session->renew(true);
		}
		else
		{
			$this->session->close();
		}
		header('Location:' . HOME_URL);
	}
	// --------------------------------------------------------------------

    public function check_is_single_login()
    {
        $https_port = g_get_item_from_file('/wns/etc/config/wac/wns_cfg_wl_g_basic.xml', 'https_port');
        if ($https_port !== '')
        {
            $temp = explode(':', $_SERVER['HTTP_HOST']);
            if ((isset($temp[1]) && intval($temp[1]) != intval($https_port)))
            {
                return true;
            }
        }
        return false;
    }
	/**
	 * 登录页
	 */
	public function login()
	{
        database_upgrade();
        //	 print_r(getallheaders());
		$file = '';
		$sess_cookie_name = $this->configs['sess_cookie_name'];
		if (isset($_COOKIE[$sess_cookie_name]))
		{
			$file = is_session_file($_COOKIE[$sess_cookie_name]);
		}
		$this->load->model('runstat_configure/runtime_model');
		$title = $this->runtime_model->get_device_name();
		$ret = array('username' => '', 'msg' => $this->_get_msg(), 
					 'times' => '', 'title' => $title);
        $this->load->model('system_management/spm_service/Spm_service_model');
        $spm = $this->Spm_service_model->get_recordset();
        $ret['enable_spm'] = (bool)$spm['switch'];
        $ret['spm_is_private'] = isset($spm['is_private'])?(bool)$spm['is_private']:true;
        $ret['new_status'] = $this->checkIsNewStatus();
        $this->load->model('runstat_configure/new_guest_analyse_model');
        $ret['market_field'] = $this->new_guest_analyse_model->get_market_field_name();
        $wac_role = $this->runtime_model->get_wac_role();
        $wac_mgmt_role = $this->runtime_model->get_wac_mgmt_role();
        $ret['wac_role'] = $wac_role;
        $ret['slavewac'] = is_slave_wac();
        $ret['wac_mgmt_role'] = $wac_mgmt_role;
        if(!$this->_is_vm()) {
            $this->_check_login_page($ret);
        }
		$remote_addr = $this->input->ip_address();
		$login_frozen_ip = 'login_frozen_' .$remote_addr;
		$login_fail_ip = 'login_fail_' . $remote_addr;
		$login_check_ip = 'login_check_' .$remote_addr;
		$login_frozen_ts = cache_var('get',$login_frozen_ip);
		if (false !== $login_frozen_ts) //存在登录冻结
		{
			@cache_var('delete',$login_fail_ip, null, 0);
			$duration = $login_frozen_ts - time();
			if ($duration > 0) 
			{
				$ret['msg'] = __('login_freeze', $duration);
				set_status_header(404);
				$this->load->view(__CLASS__ . '/' . __FUNCTION__, $ret);
				return;
			}
		}

		if ($this->_check_token($login_check_ip)) 
		{
			sleep(FIVE_SECONDS); //确保会话销毁
			$ret['msg'] = __('检测到有登录账号未注销，请重新登录！');
			$this->load->view(__CLASS__ . '/' . __FUNCTION__, $ret);
			return;
		}
		if (0 !== strcasecmp($_SERVER['REQUEST_METHOD'], 'GET')) //登录
		{
			if ($file) //有会话文件
			{
				if ($uid = $this->_detect_account($file)) 
				{
					if ($uid === $this->forms['username']) //账号相同，且已登录
					{
						$this->load->model('system_management/admin_account/admin_account_model');
						if ($this->admin_account_model->is_match_pwd($uid, $this->forms['password'])) 
						{
                            //规避appscan 扫描漏洞
                            $this->session->start();
                            $this->_get_org_session($file);
                            @cache_var('delete',$login_fail_ip, null, 0);
                            set_status_header(302);
                            log_message_r('error', 'redirect to index page '.__FILE__.':'.__LINE__);
                            $this->session->set_userdata('renew', 1);
                            $this->session->close();
                            $this->session->unset_userdata(Runtime_Model::LANGUAGE);
                            $this->session->renew(true);
                            delete_file($file);
                            //规避appscan 扫描漏洞
							header('Location:' . HOME_URL . '?renew=1');
							header('X-POS: '. sprintf('%s:%d', 'WEL', __LINE__));
							exit;
						}
					}
					delete_file($file);
					$this->session->clear_cookie(); //踢掉前一个登录账号
					$sid = random_string();
					cache_var('set',$login_check_ip, $sid,900);
					header(sprintf('Location:%s?check=%s', LOGIN_URL, $sid), true, 303);
					exit;
				}
			}
			if (empty($this->forms['username'])) //用户名为空
			{
				$ret['msg'] = __('username_required');
				$this->_check_freeze($ret);
				$this->load->view(__CLASS__ . '/' . __FUNCTION__, $ret);
				return;
			}

            //判断用户类型必须是营销管理员或超级管理员
            $this->load->library('acl/simple_user', null, 'user');
            $info = $this->user->get_user($this->forms['username']);
            $role_valid = $info['role'] === ROLE_NORMAL || $info['role'] === ROLE_SUPER;
//            $role_valid = true;
            $res = false;
            if($role_valid)
                $res = parent::_authenticate($this->forms['username'], $this->forms['password']); //认证
			if ($res)
			{
				if (!$info['enable']) //账号被禁用
				{
					$this->_unset_auth();
					$ret['msg'] = __('disabled_account');
					$ret['username'] = $this->forms['username'];
					$this->load->view(__CLASS__ . '/' . __FUNCTION__, $ret);
				}
				else 
				{
                    $filter = array('127.0.0.1');//考虑到单点登录，本机登录，以后不需要限制的IP写这里
                    $info['ip_range'] = array_merge($info['ip_range'],$filter);
					if (!$this->check_is_single_login() && $info['ip_enable'] &&
						!is_match_ip_range($remote_addr, $info['ip_range'])) //判断登录IP
					{
						$this->_unset_auth();
						$ret['msg'] = __('illegal_login_ip', $remote_addr);
						$ret['username'] = $this->forms['username'];
						$this->_check_freeze($ret,
							__('登录IP非法', htmlspecialchars($ret['username']),
							$remote_addr));
						$this->load->view(__CLASS__ . '/' . __FUNCTION__, $ret);
					}
					else
					{
						@cache_var('delete',$login_fail_ip, null, 0);
						$this->runtime_model->addLog('system', __('登录系统'), true);
                        $this->updateIsNewStatus();
                        //刷新营销的session； 加这段代码是为了防止漏洞扫描工具报高级漏洞用的
                        session_write_close();
                        if (isset($_COOKIE['sf_session_market']))
                        {
                            session_name('sf_session_market');
                            $file = is_session_file($_COOKIE['sf_session_market']);
                            session_start();
                            if (is_file($file)) {
                                $data = file_get_contents($file);
                                session_decode($data);
                            }else{
                                session_decode('');
                            }
                            session_regenerate_id();
                            session_write_close();
                        }        
                        
						header('Location:' . HOME_URL);
						echo("ok");
						header('X-POS: '. sprintf('%s:%d', 'WEL', __LINE__));
						exit;
					}
				}
			}
			else 
			{
				$ret['msg'] = __('account_or_password_invalid');
				$ret['username'] = $this->forms['username'];
				$this->_check_freeze($ret);
				$this->load->view(__CLASS__ . '/' . __FUNCTION__, $ret);
			}
		}
		else //未提交账号密码
		{
			if ($file) //有会话文件
			{
				if ($this->_detect_account($file)) //有会话且认证过跳到主页
				{
					$this->session->start();
					$this->_get_org_session($file);
					@cache_var('delete',$login_fail_ip, null, 0);
					set_status_header(302);
					log_message_r('error', 'redirect to index page '.__FILE__.':'.__LINE__);
					$this->session->set_userdata('renew', 1);
					$this->session->close();
					$this->session->unset_userdata(Runtime_Model::LANGUAGE);
					$this->session->renew(true);									
					//echo $this->load->view(__CLASS__ . '/redirect', array('url'=>HOME_URL), true);
					header('Location:' . HOME_URL); 
					header('X-POS: '. sprintf('%s:%d_%s', 'WEL', __LINE__,$_SERVER['REQUEST_METHOD']));
					exit;
				}
				delete_file($file);
			}
			$this->_clear_sess_cookie();
			$this->load->view(__CLASS__ . '/' . __FUNCTION__, $ret);
		}
	}
	
	// --------------------------------------------------------------------

	/**
	 * 主页
	 */
	public function home() 
	{

		
		$this->session->start();
		
		if (!$this->session->userdata('auth')) //走入这里可能是会话文件所在目录不可写，或没有足够磁盘空间
		{
			$this->_unset_auth();
			set_status_header(302);
            log_message_r('error', 'redirect to login page '.__FILE__.':'.__LINE__);
			header('Location:' . LOGIN_URL); //回登录页
			//echo $this->load->view(__CLASS__ . '/redirect', array('url'=>LOGIN_URL), true);
			header('X-POS: '. sprintf('%s:%d', 'WEL', __LINE__));
			exit;
		}
		if(is_lite_wac())
		{
			$forbinden = $this->_check_online_user();
			if($forbinden) {
				$this->_unset_auth();
				//$this->session->close();
				header(sprintf('Location:/?msg=%s', urlencode(__('在线管理员数目超过最大限制')))); //回登录页
				exit;
			}
		} 		
		$this->_set_debug();
		$_SERVER['HTTP_SESSION_TOKEN'] = $this->session->userdata(static::CSRF_TOKEN);
		if (!$this->session->userdata('renew') || 1 == @$_REQUEST['renew'])
		{
			$this->session->set_userdata('renew', 1);
			$this->session->close();
			$this->session->unset_userdata(Runtime_Model::LANGUAGE);
			$this->session->renew(true);
		}
		else
		{
			$this->session->close();
		}
	}

	// --------------------------------------------------------------------

	/**
	 * 注销
	 */
	public function logout() 
	{
		$this->session->start();
		
		if ($this->session->userdata('auth'))
		{
			$this->load->model('auth_configure/user/auth_localuser_model');
			$this->auth_localuser_model->clear_tmp_user_cert_folder();
			$this->runtime_model->addLog('system', __('退出系统'), true);
		}
		$this->_set_console_timeout(time());
		$this->_unset_auth();
		$ret['data']= microtime(true);
		$this->log->flush($ret);
	}

	// --------------------------------------------------------------------

	/**
	 * 登录冻结
	 * 
	 * @param		$ret		array		数组
	 * @param		$reason		string		原因
	 */
	protected function _check_freeze(& $ret, $reason = '') 
	{
		$times = intval($this->configs['login_fail_times']);
		$remote_addr = $this->input->ip_address();		
		$name = 'login_fail_' . $remote_addr;
		if ($times > 0) //启用登录冻结
		{
			$cache = cache_var('get',$name);
			if (is_empty($cache)) 
			{
				$cache = 0;
			}
			$ret['times'] = $cache + 1; //第几次登录失败
			if ($ret['times'] >= $times) 
			{
				$expired = intval($this->configs['login_fail_freeze']);
				$ret['msg'] .= "\n" . __('login_freeze', $expired);
				set_status_header(404);
				$ts = time();
				cache_var('set',
					'login_frozen_' . $remote_addr, 
					$ts + $expired, 
					$expired); //冻结该IP
				cache_var('delete',$name, null, 0);
				$this->runtime_model->addLog('system', 
					__('登录IP冻结', $remote_addr, $expired), true);
					
			}
			else 
			{
				$left = $times - $ret['times'];
				if (in_array($left, $this->_last_changes)) 
				{
					$ret['msg'] .= "\n" . __('remaining_opportunity', $left);
				}
				
				cache_var('set',$name, $ret['times'],900);
				$this->runtime_model->addLog('system', 
					__('尝试登录', htmlspecialchars($ret['username']), $remote_addr, 
						$ret['times'], $reason), false);
			}
		}
	}

	// --------------------------------------------------------------------

	/**
	 * 检查登录页是否被串改
	 * 
	 * @param		$ret		array		数组
	 * @param		$reason		string		原因
	 */
	protected function _check_login_page(& $ret, $reason = '') 
	{
		$page = '/wns/webui/application/views/Welcome/login.php';
		$cmd = sprintf('/usr/sbin/sinforauthtool -op 4 %s', 
					   escape_shell_arg($page));
		$str = exec($cmd, $output, $code);
		$json = @json_decode($str, true);
		if ($json && isset($json['errno'], $json['result'])) 
		{
			if (0 === $json['errno'] && false === strpos($json['result'], 'not')) 
			{
				return;
			}
		}

		if (is_empty($reason)) 
		{
			$reason = __('登录页面异常，请联系管理员！');
		}
		$ret['virus'] = $reason;
		$this->load->view(__CLASS__ . '/index', $ret);
		$this->output->_display();
		exit;
	}

	// --------------------------------------------------------------------

	/**
	 * 检测是否存在登录账号
	 * 
	 * @return		false|string			成功返回账号名称，失败返回false
	 */
	protected function _detect_account($file) 
	{
		if (is_file($file)) 
		{
			$sess_origin = isset($_SESSION) ? $_SESSION : array();
			$sess_current = array();
			$data = file_get_contents($file);
			if ($data && @session_start() && session_decode($data)) 
			{
				$sess_current = $_SESSION;
				$_SESSION = $sess_origin;
			}
			@session_write_close();
			header_remove('Set-Cookie');

			$ip = $this->input->ip_address();
			$ua = $this->input->user_agent();
			$len = 120; //取120个字符足够了
			$ua = substr($ua, 0, $len);
			$timestamp = $this->input->server('REQUEST_TIME');
			if (0 === strcmp($sess_current['ip_address'], $ip) && 
				0 === strcmp($sess_current['user_agent'], $ua) && 
				$timestamp < @$sess_current['userdata']['console_timeout'] &&
				$sess_current['userdata']['auth']) 
			{
				return $sess_current['userdata']['uid'];
			}
		}
		return false;
	}
	// --------------------------------------------------------------------

	/**
	 * 检测是否存在登录账号
	 * 
	 * @return		false|string			成功返回账号名称，失败返回false
	 */
	protected function _get_org_session($file) 
	{
		if (is_file($file)) 
		{
			$data = file_get_contents($file);
			if ($data && @session_start() && session_decode($data)) 
			{
			}
			@session_write_close();
			header_remove('Set-Cookie');
			return true;
		}
		return false;
	}
	// --------------------------------------------------------------------

	/**
	 * 检查check参数
	 * 
	 * @param		string		$token		token
	 * @return		bool
	 */
	protected function _check_token($token) 
	{
		if (isset($_REQUEST['check'])) 
		{
			$sid = @cache_var('get',$token);
			@cache_var('delete',$token, null, 0);
			if ($_REQUEST['check'] === $sid) 
			{
				return true;
			}
		}
		return false;
	}

	// --------------------------------------------------------------------

	/**
	 * 下载帮助文档->802.11schema.ldf
	 * 
	 */
	public function download_schema() 
	{
		$file = '/wns/webui/WLAN/help/other_res/802.11schema.ldf';
		$filename = mb_pathinfo($file, PATHINFO_BASENAME);
		$this->load->helper('download');
		$rs = force_download($filename, $file);
		if (!$rs) 
		{
			parent::_download('');
		}
	}

	// --------------------------------------------------------------------

	/**
	 * 下载自定义认证页面模板
	 * 
	 */
	public function download_portal() 
	{
		$form = $this->_get_query_form();
		$this->load->model('object_configure/auth/obj_auth_model');
//		$form['folder'] = $this->obj_auth_model->get_folder_id_by_id($form['folder']); //真正的目录名
		$dir = '/wns/etc/config/portal/' . $form['folder'];

		$filenametmp = 'portal_demo';

//		switch ($form['type']) 
//		{
//			case 'ad':
//			case 'ad_disclaimer':
//				$dir .= 'ad-tpl';
//				break;
//			case 'disclaimer':
//				$dir .= 'disclaimer-tpl';
//				break;
//			default:
//				$dir .= 'default-tpl';
//				break;
//		}

		if ('fullad-tpl' === $form['type'])
		{
			$adfull = $this->obj_auth_model->get_adfull_folder_id();
			$form['folder'] = $adfull;
			$dir = '/wns/etc/config/portal/' . $form['folder'];
			unset($adfull);
		}

		if (isset($form['id']))
		{
			$temp_info = $this->obj_auth_model->get_auth_page_by_id($form['id']);
			$form['folder'] = $temp_info['folder_id'];
			$dir = '/wns/etc/config/portal/' . $form['folder'];
			$filenametmp = $temp_info['name'];
			unset($temp_info);
		}

		$this->load->library('export');
		$filename = sprintf('%s.zip', $filenametmp);
		$path = $this->export->get_path($filename);
		$rs = false;
		if (false !== $form['folder'] && is_dir($dir)) 
		{
			$file = $path . '.zip';
			$cmd = sprintf("cd %s;/usr/bin/zip -r %s .", $dir, $file);
			exec($cmd, $output, $code);
			if (0 === $code) 
			{
				$rs = rename($file, $path);
			}
		}
		
		if (!$rs) 
		{
			parent::_download('');
		}
		$seed = $this->export->get_seed();
		parent::export();
		$this->_download($seed);
		$this->log->flush();
	}

    public function download_app_portal()
    {
        $form = $this->_get_query_form();
        $this->load->model('object_configure/auth/obj_app_auth_model');
        if($form['type'] == 'app_download')
        {
            $info = $this->obj_app_auth_model->get_default();
        }else{
            $info = $this->obj_app_auth_model->get_record_by_id($form['id']);
        }
        if(!$info)
            bug(__('record_unexist'));
        $filenametmp = $info['name'];
        $dir = '/wns/etc/config/portal/' . $info['folder_id'];

        $this->load->library('export');
        $filename = sprintf('%s.zip', $filenametmp);
        $path = $this->export->get_path($filename);
        $rs = false;
        if (false !== $form['folder'] && is_dir($dir))
        {
            $file = $path . '.zip';
            $cmd = sprintf("cd %s;/usr/bin/zip -r %s .", $dir, $file);
            exec($cmd, $output, $code);
            if (0 === $code)
            {
                $rs = rename($file, $path);
            }
        }

        if (!$rs)
        {
            parent::_download('');
        }
        $seed = $this->export->get_seed();
        parent::export();
        $this->_download($seed);
        $this->log->flush();
    }

	public function downloadWifiQr()
	{
		$wifiqrcodetxt = '/wns/etc/config/wac/wifiqrcode.txt';
		$imgpath = '/tmp/ci/qrcode.png';
        $this->load->model("wireless_configure/wireless_network/wl_network_model");
        $ssid = $this->wl_network_model->get_wx_id_ref();
        if($ssid === false)
        {
            bug(__("未微信连WiFi的无线网络"));
        }
		if(file_exists($wifiqrcodetxt))//有下载过
		{
			$wifiqrcodetxtcon = file_get_contents($wifiqrcodetxt);
			if($wifiqrcodetxtcon === $ssid)
			{
				if(file_exists($imgpath))
				{
					$filename = mb_pathinfo($imgpath, PATHINFO_BASENAME);
					$this->load->helper('download');
					$rs = force_download($filename, $imgpath);
					if (!$rs)
					{
						parent::export();
						$this->_download('');
					}
					$this->log->flush();
					return;
				}
			}
		}//没下载过走后面
//		$access_token = file_get_contents('http://203.195.135.219/weixin_wifi/access_token.txt');
		$access_token = file_get_contents_secure('http://wifiauth.sundray.com/weixin_wifi/access_token.php');
		$access_token_arr = json_decode($access_token, true);
		if(!isset($access_token_arr['access_token']) || is_empty($access_token_arr['access_token']))
		{
			bug(__('access_token 不存在'));
		}
		$qr_url = 'https://api.weixin.qq.com/wifi/getQRCode.xhtml?access_token='.$access_token_arr['access_token'].'&ssid='.urlencode($ssid).'&bgUrl=http://203.195.135.219/lijin/sundray.png&format=json&storeId=10010';
		header("Content-type:text/html; charset=utf-8");
		$qrUrlStr = $this->getToken($qr_url);
		$qrUrlArr = json_decode($qrUrlStr, true);
		if (isset($qrUrlArr['qrCodeUrl']) && !is_empty($qrUrlArr['qrCodeUrl']))
		{
			$qrimg = file_get_contents_secure($qrUrlArr['qrCodeUrl']);
			file_put_contents($imgpath, $qrimg);
			file_put_contents($wifiqrcodetxt, $ssid);	//写一个同名ssid有下载过的标记文件
			$filename = mb_pathinfo($imgpath, PATHINFO_BASENAME);
			$this->load->helper('download');
			$rs = force_download($filename, $imgpath);
			if (!$rs)
			{
				parent::export();
				$this->_download('');
			}
		}
		$this->log->flush();
	}

	protected function getToken($url)
	{
		$this_header = array(
			"content-type: application/x-www-form-urlencoded;charset=UTF-8"
		);
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL,$url);
		curl_setopt($ch, CURLOPT_HTTPHEADER, $this_header);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
		return curl_exec($ch);
	}
// --------------------------------------------------------------------

	/**
	 * 获取在线用户数个数
	 */
	public function get_oun() 
	{
		//检查在线用户数
		$dir =  $this->configs['linux_tmp_folder'];
		$expire = intval(config_item('console_timeout')) * ONE_MINUTE; //超时时长，单位：秒
		$now = time();
		$last = $now - $expire;
		$cnt = 0;
		foreach (glob($dir . 'sess_*') as $path)
		{
			if (is_file($path) && strpos(file_get_contents($path), 's:4:"auth";b:1;')) 
			{
				$ctime = filectime($path);
				$mtime = filemtime($path);
				
				$max =  max($ctime, $mtime);
				//如果session文件超过一分钟没有更新则认为这个session文件无效
				if(($now-$max)>ONE_MINUTE)
				{
					continue;
				}
				if ($max > $last) 
				{
					++$cnt;
				}
			}
		}
		return $cnt;
	}
	// --------------------------------------------------------------------

	/**
	 * 在线用户数检查
	 */
	public function _check_online_user() 
	{
		
        $cnt = $this->get_oun();
		$max_login_user = 3;
		if($cnt > $max_login_user)
		{
		   return true;
		}
		return false;
	}
	// --------------------------------------------------------------------

	/**
	 * 打印在线用户数
	 */
	public function print_oun() 
	{
		
        $cnt = $this->get_oun();
		echo 'online user:'.$cnt;
	}
    /**
     * 获取版本数据和设备名称
     */
    public function get_version_info()
    {
        $ret['title'] = $this->runtime_model->get_device_name();
        $ret['info'] = str_replace(" ", '&nbsp;', str_replace("\n", '<br/>', htmlspecialchars(file_get_contents('/app/appversion'))));
        return json_encode($ret);
    }


    /**
     *获取二维码直接输出，无需认证
     */
    public function get_qrcode_pic()
    {
        $this->load->library('qrcode');
        $url = $this->input->get_post('url',true);
        $path = $this->qrcode->save_png($url);
        header('Content-type: image/png');
        echo file_get_contents($path);
        @unlink($path);
    }

    public function upgrade()
    {
        if(!check_database_upgrade())
        {
            set_status_header(302);
            log_message_r('error', 'redirect to login page '.__FILE__.':'.__LINE__);
            header('Location:' . HOME_URL); //回登录页
            exit;
        }
        $this->load->view(__CLASS__ . '/' . __FUNCTION__);

    }

    public function getUpgrdPercent()
    {
        $upg_log = DATABASE_UPGRADE_LOG;
        if(!check_database_upgrade())
        {
            $ret['data'] =  array('done'=>true);
            $this->log->flush($ret);
        }
        exec("tail -n 1 {$upg_log}",$row,$code);
        $data = preg_split('/\s+/',@$row[0]);
        $ret = array();
        if(!empty($data))
        {
            $ret['data'] = array(
                'module'=>__(@$data[0]),
                'percent'=>isset($data[1])?$data[1]:0,
                'current'=>isset($data[2])?$data[2]:0,
                'total'=>isset($data[3])?$data[3]:0,
                'done'=>false,
            );
        }
        $this->log->flush($ret);
    }



    /**
     *登录后更新新状态的状态文件
     */
    protected function updateIsNewStatus()
    {
        if($this->checkIsNewStatus())
        {
            $content = json_decode(file_get_contents(self::CHECK_IS_NEW_STATUS_FLAG),true);
            if(empty($content))
                $content = ['log'=>[],'cnt'=>0];
            $date = date('Y-m-d',time());
            if(isset($content['log'][$date]))
                $content['log'][$date] ++;
            else
                $content['log'][$date] = 1;
            $content['cnt'] = count($content['log']);
            file_put_contents(self::CHECK_IS_NEW_STATUS_FLAG,json_encode($content));
        }
    }

    /**
     * 校验单点登录token
     * @param $token
     */
    private function _check_sso_login_token($token)
    {
        if (empty($token))
        {
            return false;
        }

        try{
            $this->load->library('SF_JWT');
            $rs = $this->sf_jwt->decode($token);
            if ($rs)
            {
                $cont = $this->sf_jwt->get_payload();
                if ($_SERVER['REQUEST_TIME'] > $cont['exp'])
                {
                    log_message_r('error',__('file:%s,func:_check_sso_login_token error.msg:timeout!',__FILE__));
                    return false;
                }
                $this->load->model('sys_configure/central_monitor/central_model');
                $self = $this->central_model->get_global_release_pwd();
                if (isset($self['pwd']))
                {
                    if ($cont['check'] === md5($self['pwd']))
                    {
                        return true;
                    }

                    log_message_r('error',__('file:%s,func:_check_sso_login_token error.msg: check error',__FILE__));
                    return false;
                }

                log_message_r('error',__('file:%s,func:_check_sso_login_token error.msg:$self is empty!',__FILE__));
                return false;
            }
        }catch (Exception $e)
        {
            log_message_r('error',__('file:%s,func:_check_sso_login_token error.msg:%s',__FILE__,$e->getMessage()));
            return false;
        }
    }
}