<?php

require_once('/wns/webui/application/third_party/wns_phpext/wns_ipc.php');
require_once('/wns/webui/application/third_party/proto/msg/msgid_webui.php');
require_once('/wns/webui/application/third_party/proto/msg/webui_msg_common.php');
require_once('/wns/webui/application/third_party/proto/msg/webui_msg_cmd_helper.php');

function cmd_exec($cmd, &$output = null, &$retval = -1, $timeout = 120) {
	$msg = new \webui_msg\send_cmd();
		$msg->setCmd($cmd);
		$bincodec = new \DrSlump\Protobuf\Codec\Binary();
		$bin = $bincodec->encode($msg);
		$data = php_wns_ipc_to_self(\wns\module_id_e::CMD_HELPER_SRVD, 
									0, 
									\webui_msg\msgid_cmd_helper::SEND_CMD_C,
									$bin,
									\webui_msg\msgid_cmd_helper::SEND_CMD_R, 
									$timeout);
		if (isset($data['buf'])) 
		{
			$result = $bincodec->decode(new \webui_msg\reply_result(), $data['buf']);
			
			 $retval = $result->getCode();
		}
		
		return $retval;

}

/**
 * 混淆文件名
 * @param $file_id
 * @return string
 */
function get_confused_filename($file_id)
{
	$cipher_method = "aes-128-cbc";
	$key = 'p14y3jx12895nvpg847zr4emq6dlkbxd';
	$iv = 'mlrdgwy1vy1k6x39';//16位
	$cipher_text = openssl_encrypt($file_id, $cipher_method, $key, 0, $iv);
	$cipher_text_b64e = base64_encode($cipher_text);
	return $cipher_text_b64e;
}

function check_plain_file_by_content($file_path)
{
	if(file_exists($file_path)){
		$content = file_get_contents($file_path);
		if (is_string($content))
		{
			if(strpos($content, "<?") || strpos($content, "#!") ||
			strpos($content, "\"auth\";b:1"))
			{
				return false; //是文本内容，内容包含了危险前缀<? #! 或者 sess敏感信息
			}
		}
	}
	return true;
}


/**
 * 1、检查js传过来的ID
 * 2、检查上传的文件mime和后缀是否在白名单里
 * @param $file_path
 * @param $file_name
 * @param $upload_id
 * @param $type
 * @return bool 符合条件返回true，否则返回false
 */
function check_mime($file_path, $file_name, $upload_id, $type = 'nac')
{
	$valid_mime_types_nac = [
		'application/octet-stream' => [
			'ssu', 'ssu1', 'ssu2', 'zip', 'tgz',
			'7z', 'rar',
			'wa', 'bcf', 'img',
			'cer', 'p7b', 'pfx', 'p12',//@证书管理
			'mp3', 'wav', 'aac', 'ape', 'ogg', 'wma', 'amr',//音频 @音频管理
		],//二进制流，一般识别不出来就会是这种 @升级包/天气插件/配置备份
		'application/zip' => ['zip'],//@终端页面/应用特征识别库/url规则库/终端类型库/人脸数据库/人脸信息
		'application/x-rar' => ['rar'],//@url规则库
		'application/x-gzip' => ['tgz'],//@升级包/补丁包
		'application/x-7z-compressed' => ['7z'],//@数据分析库
		'application/xml' => ['xml'],//@应用标签
		'text/plain' => [
			'csv',//@ap/switch/静态路由/地址转换/本地用户/用户终端绑定/MAC地址库/问卷题库/关键字组/终端数据库
			'crt', 'cer', 'p7b', 'pem', 'crl', 'pfx', 'p12',//@证书管理
			'conf',
			'wsdl', 'xsd', //短信验证码的模板上传
		],//文本类型
		'text/html' => ['svg'],//html文本 @终端页面
		'image/*' => ['jpg', 'jpeg', 'svg', 'gif', 'png', 'bmp','ico'],//图片 @终端页面
		'audio/*' => ['mp3', 'wav', 'aac', 'ape', 'ogg', 'wma', 'amr'],//音频 @音频管理
	];//mime类型与扩展名的对应关系，控制器平台
	$valid_mime_types_iotp = [
		'text/html' => ['svg'],//html文本
		'image/*' => ['jpg', 'jpeg', 'png', 'gif'],
		'text/plain' => ['csv', 'key', 'crt'],
		'application/octet-stream' => ['gz', '7z', 'zip'],
		'application/x-7z-compressed' => ['7z'],
		'application/x-tar' => ['tar'],
		'audio/*' => ['mp3', 'wav', 'ogg'],
		'application/ogg' => ['ogg'],
	];//mime类型与扩展名的对应关系，物联网平台
	$valid_mime_types = $type === 'iotp' ? $valid_mime_types_iotp : $valid_mime_types_nac;
    $blacklist_ext = ['asp','php','jsp','php5','asa','aspx','sh','lua'];
	if (!preg_match('/^[\w- ]+$/', $upload_id))
	{//字母、数字、下划线、短线、空格
		return false;
	}

	if (!file_exists($file_path)) return true;//文件不存在也返回true
	exec('file -b --mime-type -m /usr/share/misc/magic '. $file_path, $output, $code);
	if (0 === $code && isset($output[0]))
	{
		$mime_type = $output[0];
		$mime_type_wildcard = explode('/', $mime_type)[0]. '/'. '*';//类别通配符，比如image/*
		$file_ext = strtolower(pathinfo($file_name, PATHINFO_EXTENSION));//文件扩展名
        if(in_array($file_ext, $blacklist_ext))
		{
		    return false;
		}
        $valid = (
            (isset($valid_mime_types[$mime_type]) && in_array($file_ext, $valid_mime_types[$mime_type])) ||
            (isset($valid_mime_types[$mime_type_wildcard]) && in_array($file_ext, $valid_mime_types[$mime_type_wildcard]))
        );
        if($valid === true && $mime_type === 'text/plain')
        {
			$valid = check_plain_file_by_content($file_path);
        }
        return $valid;
	}
	else
	{
		return true;//获取不到时默认返回true
	}
}

/**
 * 简易日志
 * @param $msg
 */
function debug_log($msg)
{
	$ip = $_SERVER['REMOTE_ADDR'];
	$uri = $_SERVER['REQUEST_URI'];
	$var_str = var_export($msg, true);
	$log_str = sprintf("[%s]%s:\n%s\n", $ip, $uri, $var_str);
	file_put_contents('/tmp/debug.log', $log_str, FILE_APPEND);
}

if(isset($_GET['X-Progress-ID']))
{
	$php_upload_dir = '/tmp/ci/temp/';
	if (!check_mime($_POST['file_path'], $_POST['file_name'], $_GET['X-Progress-ID']))
	{
		header('HTTP/1.1 400 Bad Request');//nginx会自动删除上传的文件
		die('invalid filename');
	}

	$nginx_file = escapeshellarg($_POST['file_path']);
	$dst_filename = $_GET['X-Progress-ID'];

	$cmd = sprintf('chmod 0644 %s && mv %s %s', $nginx_file,
		$nginx_file, escapeshellarg($php_upload_dir. $dst_filename));
	$code = cmd_exec($cmd);
	if($code !== 0)
	{
	   cmd_exec('rm -f '. $nginx_file);
	   die('upload fail');
	}

	die('{success: true, msg: "upload complete"}');
}
elseif(isset($_GET['X-Progress-ID-IOTP']))
{//2017-02-07 用于iotp内置wac 文件上传
	$php_upload_dir = '/wns/data/iotp/spm/data/shared/tmpfile/';
	if (!check_mime($_POST['file_path'], $_POST['file_name'], $_GET['X-Progress-ID-IOTP'], 'iotp'))
	{
		header('HTTP/1.1 400 Bad Request');
		die('{"success": false}');
	}

	$nginx_file = escapeshellarg($_POST['file_path']);
	$dst_filename = $_GET['X-Progress-ID-IOTP'];

    if($_POST['file_size'] > 1024*1024*500)
    {//文件上传大小最大不能超过500M
        die('{"success": false}');
    }
	if(!is_dir($php_upload_dir))
	{//判断iotp文件目录是否存在
		$cmd = sprintf("mkdir -p %s", $php_upload_dir);
		cmd_exec($cmd);
	}

	$cmd = sprintf('chmod 0644 %s && mv %s %s', $nginx_file,
		$nginx_file, escapeshellarg($php_upload_dir. $dst_filename));
	$code = cmd_exec($cmd);
	if($code !== 0)
	{
		cmd_exec('rm -f '. $nginx_file);
		$ret = '{"success": false}';
	}
	else
	{
		$ret = '{"success": true}';
		//$cmd = 'chroot /wns/data/iotp  mod_iotp_tmpfile.sh'; //改变iotp 文件目录所有权限
		//$code = cmd_exec($cmd);
	}
	die($ret);
}

?>
